> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Service Account

> Updates a service account.

`Unary` · [`Service Accounts`](https://ona.com/docs/api-reference/generated/service-account/overview)

Updates a service account.

Use this method to:

* Update service account name or description

### Examples

* Update name and description:

  Updates the service account name and description.

  ```yaml theme={null}
  serviceAccountId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  name: "updated-ci-pipeline"
  description: "Updated CI/CD Pipeline"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.ServiceAccountService/UpdateServiceAccount
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.ServiceAccountService/UpdateServiceAccount" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "serviceAccountId": "<service-account-id>"
}'
```

```python Python theme={null}
import gitpod.v1.service_account_pb2 as service_account_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = service_account_pb2.UpdateServiceAccountRequest(
    service_account_id="<service-account-id>",
)
response = ona.services.service_account.update_service_account(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { UpdateServiceAccountRequestSchema } from "@gitpod/sdk/gitpod/v1/service_account_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(UpdateServiceAccountRequestSchema, {
    serviceAccountId: "<service-account-id>",
  });
  const response = await ona.services.serviceAccount.updateServiceAccount(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.UpdateServiceAccountRequest{
		ServiceAccountId: "<service-account-id>",
	})
	response, err := ona.Services.ServiceAccount.UpdateServiceAccount(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "serviceAccountId": "<service-account-id>"
}
```

## Request

`gitpod.v1.UpdateServiceAccountRequest`

| Field | Type | Required | Description |
| - | - | - | - |
| `serviceAccountId` | string | No | Constraints: `string.uuid=true`. |
| `name` | string | No | Optional fields for update Constraints: `string.max_len=64, string.min_len=1`. |
| `description` | string | No | Constraints: `string.max_len=500`. |

## Response

`gitpod.v1.UpdateServiceAccountResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `serviceAccount` | [ServiceAccount](#type-gitpod-v1-service-account) | Yes | Constraints: `required=true`. |

## Related types

> [accordion] ServiceAccount
>
> `gitpod.v1.ServiceAccount`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `id` | string | No | Constraints: `string.uuid=true`. |
> | `organizationId` | string | No | Constraints: `string.uuid=true`. |
> | `name` | string | No | |
> | `description` | string | No | |
> | `creator` | [Subject](#type-gitpod-v1-subject) | No | |
> | `createdAt` | RFC 3339 timestamp | No | |
> | `validUntil` | RFC 3339 timestamp | No | |
> | `suspended` | boolean | No | suspended indicates whether the service account has been deleted (soft-delete). Suspended service accounts cannot be used for authentication. |
> | `systemManaged` | boolean | No | system\_managed indicates whether this is a system-managed service account. System-managed service accounts cannot be modified or deleted by users. |

> [accordion] Subject
>
> `gitpod.v1.Subject`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `id` | string | No | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`. |
> | `principal` | [Principal](#enum-gitpod-v1-principal) | No | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |

> [accordion] Principal
>
> | Value | Number | Description |
> | - | -: | - |
> | `PRINCIPAL_UNSPECIFIED` | 0 | |
> | `PRINCIPAL_ACCOUNT` | 1 | |
> | `PRINCIPAL_USER` | 2 | |
> | `PRINCIPAL_RUNNER` | 3 | |
> | `PRINCIPAL_ENVIRONMENT` | 4 | |
> | `PRINCIPAL_SERVICE_ACCOUNT` | 5 | |
> | `PRINCIPAL_RUNNER_MANAGER` | 6 | |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.